/*
	$Id: Macro.java 309 2007-03-24 21:57:27Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;

/**
   ޥǤ
*/
public class Macro {

    /** 롼 */
    private Group group;

    /** ޥ̾ */
    private Strings name;

    /** Υå */
    private MacroParameters params;

    /** macroǤ */
    private String macro;

    /** descǤ */
    private Description desc;

    /**
       ޥޤ

       @param g 饹
       @param elem define
    */
    public Macro(final Class g, final Element elem) {
	group = g;
	name = g.expandNS(elem, "name");

	ChildrenFilter c = new ChildrenFilter(elem);
	params = new MacroParameters(
	    g, c.getDirectChildrenByTagName("macroparam"),
	    c.getDirectChildrenByTagName("variableparam"));
	macro = getMacro(c.getDirectChildrenByTagName("macro"));
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       macroǤƤޤ

       @param nodes macroǤΥΡɥꥹ
       @return macroǤ
    */
    private String getMacro(final NodeList nodes) {
        if (nodes.getLength() == 0) {
            return "";
	}
        Node node = (Element) nodes.item(0);
	String s = "";
        NodeList children = node.getChildNodes();
        for (int i = 0; i < children.getLength(); ++i) {
            Node child = children.item(i);
            if (child.getNodeType() == Node.TEXT_NODE) {
                s += child.getNodeValue();
            }
	}
	return s;
    }

    /**
       ޥ̾ޤ

       @return ޥ̾
    */
    public Strings getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	int k;
	String args, s = macro.trim();
	Parameter p = params.getParameter(0);

	if (p != null) {
	    args = "(" + p.getCode();
	    for (k = 1; (p = params.getParameter(k)) != null; ++k) {
		args += ", " + p.getCode();
	    }
	    args += ")";
	} else {
	    args = "";
	}

	if (s.indexOf('\n') == -1) {
	    wr.println(""
+ "#define " + name + args + " " + macro);
	    return;
	}

	wr.print("#define " + name + args + " \\\n\t");
	while ((k = s.indexOf('\n')) >= 0) {
	    wr.print(s.substring(0, k) + " \\\n\t");
	    s = s.substring(k + 1);
	}
	wr.println(s);
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name.getShorten() + "</b></a>"
+ params.getHTML(group) + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.print(""
+ "<p><a name=\"" + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name.getShorten() + "</b></font>"
+ "</p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap><b>" + name.getShorten() + "</b>"
                       + params.getHTML(group) + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	params.printDetail(wr);

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	Parameter p = params.getParameter(0);
	String texName = Tex.safe(name.getShorten());

	wr.println("\\Sid{" + texName + "}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.print("{\\bfseries " + texName + "}");
	if (p != null) {
	    wr.print("(" + p.getTEX(group));
	    for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
		wr.print(", " + p.getTEX(group));
	    }
	    wr.println(")");
	} else {
	    wr.println("");
	}
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.println(desc.getTexText());

	// Parameters
	params.printTexDetail(wr);
    }
}
