/*
	$Id: Method.java 309 2007-03-24 21:57:27Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import java.io.PrintWriter;
import org.w3c.dom.Element;

/**
   ᥽åɤǤ

   ؿޤϥ֥ȥ饯ȥ᥽åɤݴ쥯饹Ǥ
*/
public abstract class Method {

    /** 롼 */
    private Group group;

    /** ᥽åɤ̾ */
    private Strings name;

    /** Υå */
    private MethodParameters params;

    /** ҤΥå */
    private Modifiers modifiers;

    /**  */
    private Return returnElem;

    /** descǤ */
    private Description desc;

    /**
       ᥽åɤޤ

       @param g 롼
       @param elem methodǤޤabstractmethod
    */
    protected Method(final Group g, final Element elem) {
	group = g;
	name = getNameAttribute(g, elem);

	ChildrenFilter c = new ChildrenFilter(elem);
	params = new MethodParameters(
	    g, c.getDirectChildrenByTagName("param"),
	    c.getDirectChildrenByTagName("variableparam"));
	modifiers = new Modifiers(c.getDirectChildrenByTagName("modifier"));
	returnElem = new Return(g, c.getDirectChildrenByTagName("return"));
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       name°ͤ᥽åɤ̾ޤ

       @param g 롼
       @param elem methodǤޤabstractmethod
       @return ᥽åɤ̾
    */
    protected abstract Strings getNameAttribute(final Group g,
						final Element elem);

    /**
       ᥽åɤ̾ޤ

       @return ᥽åɤ̾
    */
    public Strings getName() {
	return name;
    }

    /**
       ɤϤޤ

       @param wr 饤
    */
    public void printCode(final PrintWriter wr) {
	String opener = "";
	String closer = ";";
	String pre = "";
	String post = "";
	printPrototype(wr, opener, closer, pre, post, true);
    }

    /**
       ֤ΥץȥϤޤ

       @param wr 饤
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
    */
    private void printStubPrototype(final PrintWriter wr,
				    final String opener,
				    final String closer,
				    final String pre,
				    final String post) {
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getCode();
	String s = opener + returnElem.getLeftCode() + pre + name + post + "(";
	int len = s.length();
	char[] space = new char[len];
	for (int i = 0; i < len; ++i) {
	    space[i] = ' ';
	}
	String offset = new String(space);
	wr.print(s + arg);
	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    String param;
	    if (p instanceof VariableParameter) {
		param = "va_list";
	    } else {
		param = p.getCode();
	    }
	    wr.print(",\n" + offset + param);
	}
	wr.println(")" + returnElem.getRightCode()
		   + modifiers.getCode() + closer);
    }

    /**
       ֤ΥإåϤޤ

       @param wr 饤
    */
    public void printStubHeader(final PrintWriter wr) {
	String opener = "extern ";
	String closer = ";";
	String pre = "(*stub_";
	String post = ")";
	printStubPrototype(wr, opener, closer, pre, post);
    }

    /**
       ֤ΥɤϤޤ

       @param wr 饤
    */
    public void printStubCode(final PrintWriter wr) {
	Parameter p;
	int k;

	String returnValueDeclare = "";
	String returnValueAssign = "";
	String returnValueReturn = "";
	if (!returnElem.getHTML(group).equals("void")) {
	    returnValueDeclare = "    " + returnElem.getLeftCode()
		+ "_val" + returnElem.getRightCode() + ";\n";
	    returnValueAssign = "_val = ";
	    returnValueReturn = "    return _val;\n";
	}

	String vaList = "";
	String vaStart = "";
	String vaEnd = "";
	for (k = 0; (p = params.getParameter(k)) != null
		 && !(p instanceof VariableParameter); ++k) {
	    continue;
	}
	if (p != null && k > 0) {
	    Parameter last = params.getParameter(k - 1);
	    vaList
		= "    va_list _ap;\n";
	    vaStart
		= "    va_start(_ap, " + last.getName() + ");\n";
	    vaEnd
		= "    va_end(_ap);\n";
	}

	wr.println("");
	printStubPrototype(wr, "", " = NULL;", "(*stub_", ")");
	printPrototype(wr, "", "", "", "", false);
	wr.println("{");
	wr.print(returnValueDeclare);
	wr.print(vaList);
	if (!returnValueDeclare.equals("") || !vaList.equals("")) {
	    wr.println("");
	}
	wr.print(vaStart);
	wr.print(""
		 + "    if (stub_" + name + " == NULL)\n"
		 + "        abort();\n"
		 + "    " + returnValueAssign + "stub_" + name + "(");
	p = params.getParameter(0);
	String arg = (p == null) ? "" : p.getName();
	wr.print(arg);
	for (k = 1; (p = params.getParameter(k)) != null; ++k) {
	    String param;
	    if (p instanceof VariableParameter) {
		param = "_ap";
	    } else {
		param = p.getName();
	    }
	    wr.print(", " + param);
	}
	wr.print(");\n");
	wr.print(vaEnd);
	wr.print(returnValueReturn);
	wr.print("}\n");
    }

    /**
       ץȥϤޤ

       @param wr 饤
       @param opener ץȥ˽Ϥʸ
       @param closer ץȥθ˽Ϥʸ
       @param pre ؿ̾˽Ϥʸ
       @param post ؿ̾θ˽Ϥʸ
       @param withModifiers ҤϤtrue
    */
    private void printPrototype(final PrintWriter wr,
				final String opener,
				final String closer,
				final String pre,
				final String post,
				final boolean withModifiers) {
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getCode();
	String s = opener + returnElem.getLeftCode() + pre + name + post + "(";
	int len = s.length();
	char[] space = new char[len];
	for (int i = 0; i < len; ++i) {
	    space[i] = ' ';
	}
	String offset = new String(space);
	wr.print(s + arg);
	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(",\n" + offset + p.getCode());
	}
	String m = withModifiers ? modifiers.getCode() : "";
	wr.println(")" + returnElem.getRightCode() + m + closer);
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	String prefix = "";
	String pre = "";
	String post = "";

	wr.println(""
+ "<tr>\n"
+ "  <td align=\"right\" valign=\"top\" width=\"1%\">\n"
+ "    <font size=\"-1\">&nbsp;" + returnElem.getHTML(group)
+ "</font>\n"
+ "  </td>\n"
+ "  <td valign=\"top\">"
+ pre + "<a href=\"#" + prefix + name + "\">"
+ "<b>" + name.getShorten() + "</b></a>"
+ post + "(" + params.getHTML(group) + ") "
+ group.getHTML(modifiers.getCode()) + "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	String prefix = "";
	String pre = "";
	String post = "";
	Parameter p = params.getParameter(0);
	String arg = (p == null) ? "void" : p.getHTML(group);

	wr.print(""
+ "<p><a name=\"" + prefix + name + "\"></a>"
+ "<font size=\"+1\"><b>" + name.getShorten() + "</b></font></p>\n"
+ "<table cellpadding=\"0\" cellspacing=\"0\">\n"
+ "  <tr>\n"
+ "    <td nowrap>" + returnElem.getHTML(group) + " "
		    + pre + "<b>" + name.getShorten() + "</b>"
		    + post + "(</td>\n"
+ "    <td nowrap>" + arg);

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.print(""
+ ",</td>\n"
+ "  </tr>\n"
+ "  <tr>\n"
+ "    <td></td><td nowrap>" + p.getHTML(group));
	}
	wr.println(""
+ ") " + group.getHTML(modifiers.getCode()) + "</td>\n"
+ "  </tr>\n"
+ "</table>\n"
+ "<dl>\n"
+ "<dd>" + desc.getText() + "</dd>\n");

	params.printDetail(wr);
	returnElem.printDetail(wr);

	wr.println(""
+ "</dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	Parameter p = params.getParameter(0);
	String texName = Tex.safe(name.getShorten());
	String arg, lf, indent;

	if (p == null) {
	    arg = "void";
	    lf = "";
	    indent = "";
	} else {
	    arg = p.getTEX(group);
	    lf = "\\\\\n";
	    indent = "\\Sindent ";
	}

	// Syntax
	wr.println("");
	wr.println("\\Sid{" + texName + "}");
	wr.println("\\nopagebreak");
	wr.println("\\begin{Ssyntax}%");
	wr.print(returnElem.getTEX(group) + " {\\bfseries " + texName + "}("
		 + lf + indent + arg);

	for (int k = 1; (p = params.getParameter(k)) != null; ++k) {
	    wr.println(",\\\\");
	    wr.println(indent);
	    wr.print(p.getTEX(group));
	}
	wr.println(")");
	wr.println("\\end{Ssyntax}");

	// Description
	wr.println("");
	wr.println(desc.getTexText());

	// Parameters
	params.printTexDetail(wr);

	// Returns
	returnElem.printTexDetail(wr);
    }
}
