/*
	$Id: Tex.java 305 2007-03-16 18:35:59Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

/**
   TeXϤΤΥ桼ƥƥǤ
*/
public final class Tex {

    /**
       󥹥ȥ饯Ǥ
    */
    private Tex() {
    }

    /**
       TeXǽϤǤ褦˥פʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safe(final String s) {
	String t = "";
	int n = s.length();
	boolean isLastLowerCase = false;
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    switch (c) {
	    case '>':
		t += "\\textgreater ";
		break;
	    case '<':
		t += "\\textless ";
		break;
	    case '|':
		t += "\\textbar ";
		break;
	    case '\\':
		t += "\\textbackslash ";
		break;
	    case '^':
		t += "\\textasciicircum ";
		break;
	    case '~':
		t += "\\textasciitilde ";
		break;
	    case '{':
	    case '}':
	    case '%':
	    case '&':
	    case '#':
	    case '$':
		t += "\\" + c;
		break;
	    case '_':
		t += "\\-" + "\\" + c + "\\-";
		break;
	    default:
		if (Character.isUpperCase(c) && isLastLowerCase) {
		    t += "\\-";
		}
		t += c;
		break;
	    }
	    isLastLowerCase = Character.isLowerCase(c);
	}
	return t;
    }

    /**
       hyperrefѥåhrefޥΰ˻ꤹ뤿˥
       ʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safeURL(final String s) {
	String t = "";
	int n = s.length();
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    switch (c) {
	    case '%':
	    case '_':
	    case '#':
		t += "\\" + c;
		break;
	    default:
		t += c;
		break;
	    }
	}
	return t;
    }

    /**
       hyperrefѥåhypertargetޥΰ˻ꤹ뤿˥
       פʸޤ

       @param s ʸ
       @return פʸ
    */
    public static String safeTarget(final String s) {
	String t = "";
	int n = s.length();
	for (int k = 0; k < n; ++k) {
	    char c = s.charAt(k);
	    if ((c >= '0' && c <= '9')
		|| (c >= 'A' && c <= 'Z')
		|| (c >= 'a' && c <= 'z')) {
		t += c;
	    } else {
		t += "[" + (int) c + "]";
	    }
	}
	return t;
    }
}
